#ifndef _ADDRESSSELECTIONWINDOW_H
#define _ADDRESSSELECTIONWINDOW_H

#include <QDialog>

#include "util.h"

QT_BEGIN_NAMESPACE
namespace Ui { class AddressDialog; }
QT_END_NAMESPACE

class QListWidgetItem;


// A dialog that allows the user to select a location among a list of coordinates and
// address-labels. Its most notable signals are AddressSelectionWindow::addressSelected
// and QDialog::refused, which correspond to the user's location selection.
class AddressSelectionWindow : public QDialog
{
    Q_OBJECT

public:
    AddressSelectionWindow(QWidget* parent, vector_2d_double coords, QStringList names);
    ~AddressSelectionWindow();

    virtual void accept();

    void locationActivated(QListWidgetItem* item);
    void locationSelected();

signals:
    void addressSelected(std::vector<double> point, QString name);

private:
    void populateLocationList();
    void setupUi();

    QStringList pointNames;
    vector_2d_double points;

    Ui::AddressDialog* ui;
};


#endif // _ADDRESSSELECTIONWINDOW_H
