#include "fossgis.h"

#include <QEventLoop>
#include <QJsonArray>
#include <QJsonDocument>


// The OSRM distance-calculation class, using the OSRM HTTP API. By default, the
// FOSSGIS server is used, hence the class name.
FOSSGISRouter::FOSSGISRouter(FOSSGISMapData* map_data)
{
    mapData = map_data;
}


// Return a “tables” routing URL as per the OSMR API, with the given points as parameters.
QNetworkRequest*
FOSSGISRouter::makeRoutingRequest(vector_2d_double points)
{
    QString url = mapData->serverUrl;
    url.append("/table/v1/");
    if (mapData->byCar)
	url.append("driving/");
    else
	url.append("foot/");

    for (int i = 0; i < points.size(); i++) {
	if (i > 0)
	    url.append(";");

	QString parameter =
	    QString("%1,%2").arg(points[i][1], 0, 'g', 9).arg(points[i][0], 0, 'g', 9);
	url.append(parameter);
    }

    url.append("?annotations=distance");
    return new QNetworkRequest(QUrl(url));
}
