#ifndef _FOSSGIS_H
#define _FOSSGIS_H

#include "mapdata.h"
#include "netrouter.h"

class QNetworkRequest;

// All classes relating to the OSRM engine. By default, TSPbrousek uses the
// FOSSGIS server, hence the class name.


// The OSRM map-data container. In this case, it stores only the server URL.
class FOSSGISMapData : public MapData {
    Q_OBJECT

public:
    FOSSGISMapData(QString server_base_url)
    {
	serverUrl = server_base_url;
    }

    QString serverUrl;
};



// The OSRM distance-calculation class, using the OSRM HTTP API.
class FOSSGISRouter : public NetRouter {
    Q_OBJECT

public:
    FOSSGISRouter(FOSSGISMapData* map_data);

protected:
    virtual QNetworkRequest* makeRoutingRequest(vector_2d_double points);

private:
    FOSSGISMapData* mapData;
};


#endif // _FOSSGIS_H
