#include "router.h"

#include <iostream>


// A generic loop for calculating a distance matrix by computing distances between
// both points realted to any given cell, using an overridden `pointDistance` method.
void
Router::calculateDistances(vector_2d_double points)
{
    vector_2d_int distances;
    int pointc = points.size();
    float progressIncrement = 50 / pointc;

    emit calculationProgress(50, 0, "Počítání vzdáleností…");

    for (int from_point_no = 0; from_point_no < pointc; from_point_no++) {
	std::vector<int> from_point_distances;

	for (int to_point_no = 0; to_point_no < pointc; to_point_no++) {
	    if (from_point_no != to_point_no) {
		int distance =
		    pointDistance(points[from_point_no][0], points[from_point_no][1],
				  points[to_point_no][0], points[to_point_no][1]);
		from_point_distances.push_back(distance);
	    } else
		from_point_distances.push_back(0);
	}
	distances.push_back(from_point_distances);

	emit calculationProgress(0, progressIncrement, "Počítání vzdáleností…");
    }

    emit distancesCalculated(points, distances);
}
