#ifndef _UTIL_H

#include <vector>

class QString;


// Convenience datatypes
typedef std::vector<std::vector<double>> vector_2d_double; // Used for lists of coordinates
typedef std::vector<std::vector<int>> vector_2d_int;     // Used for lists of distances


// Misc. utility functions
bool is_coord_string(const QString str);
QString coord_vector_to_string(std::vector<double> point);
QString coord_vector_to_colon_delimited_string(std::vector<double> point);
QString coord_vector_w_label_to_string(std::vector<double> point, QString label);
std::vector<double> coord_string_to_vector(const QString coordString);

void print_point_distances_verbosely(
    vector_2d_double points, vector_2d_int distances, const char* engine);
void print_point_distances_csv(
    vector_2d_double points, vector_2d_int distances);

QString generic_api_error_to_message(QString server_error);


#endif // _UTIL_H
